
template <class VoxelType>
inline short VolumeStore<VoxelType>::inqX() const { return m_x; }

template <class VoxelType>
inline short VolumeStore<VoxelType>::inqY() const { return m_y; }

template <class VoxelType>
inline short VolumeStore<VoxelType>::inqZ() const { return m_z; }

template <class VoxelType>
inline float VolumeStore<VoxelType>::normalized(short x, short y, short z)
{
	return value(x,y,z) / (float)(inqMax() - inqMin());
}

template <class VoxelType>
inline float VolumeStore<VoxelType>::value(short x, short y, short z)
{
  float tmp;
  if (m_doscaling) { tmp=m_slope * this->operator()(x,y,z) + m_intercept; }
  else { tmp=this->operator()(x,y,z); }
  return tmp;
}



template <class VoxelType>
inline VoxelType& VolumeStore<VoxelType>::operator()(short x, short y, short z)
{
	return m_buffer[((z * m_y) + y) * m_x + x];
}

template <class VoxelType>
inline VoxelType& VolumeStore<VoxelType>::operator()(unsigned int offset)
{
	return m_buffer[offset];
}


template <class VoxelType>
inline void VolumeStore<VoxelType>::setValue(short x, short y, short z,float value)
{
  if(x >= 0 && x < m_x &&
     y >= 0 && y < m_y &&
     z >= 0 && z < m_z)
    {
      m_buffer[((z * m_y) + y) * m_x + x] = (VoxelType)value;  
    }

}

