/*  FSLView - 2D/3D Interactive Image Viewer

    James Saunders, David Flitney and Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2002-2003 University of Oxford  */

/*  CCOPYRIGHT */

#include "filemanager.h"
#include "lookuptable.h"
#include "stdio.h"
#include <qobject.h>
#include <ctype.h>


FileManager::FileManager()
{
 
}

FileManager::~FileManager()
{

}

void  FileManager::readLutFile(const std::string& filename, LookUpTable* lut)
{
  float red, blue, green;
  char chLine[64] = "";
  int linenumber = 0,count = 0;
  
  FILE* fp = fopen(filename.c_str(),"r");
  // FILE* out = fopen("render3t.ldt","w");
  if(!fp){warning("Could not open file."); return;}

  fseek(fp,0,SEEK_SET);
  
  while(fgets(chLine,64,fp)){if(strncmp(chLine,"<-color{",8) == 0) ++count;} 

  lut->allocateMemory(count);

  fseek(fp,0,SEEK_SET);

  while(fgets(chLine,64,fp))
  {
    if(strncmp(chLine,"<-color{",8) == 0)
      {
      sscanf(chLine + 8,"%f , %f , %f",&red,&green,&blue);
      lut->pushValue((unsigned char)(red*255.0),(unsigned char)(green*255.0), (unsigned char)(blue*255.0),
                     linenumber);
      //    fprintf(out,"\"%f,%f,%f\",\n",red,green,blue);
      ++linenumber;
      }    
  }
  fclose(fp);
  // fclose(out);
}  

void  FileManager::readRgbFile(const std::string& filename, LookUpTable* lut)
{
  int  index, red, blue, green,
       idxVal(0),idxValMax(0);
  char name[64]   = "";
  char chLine[128] = "";
  char idxStr[10] = "";
  char firstChar;

  FILE* fp = fopen(filename.c_str(),"r");
  if(!fp){warning("Could not open file."); return;}

  fseek(fp,0,SEEK_SET);

  while(fgets(chLine,128,fp))
    {
      sscanf(chLine," %c",&firstChar);

      if(isdigit(firstChar))
        {      
          sscanf(chLine," %s",idxStr);
          idxVal = atoi(idxStr);
          if (idxVal > idxValMax)idxValMax = idxVal;
        }

    }

  lut->allocateMemory(idxValMax + 1);

  fseek(fp,0,SEEK_SET);

  while(fgets(chLine,128,fp))
  {
    sscanf(chLine," %c",&firstChar);
    if(isdigit(firstChar))
      {
        sscanf(chLine,"%i %s %i %i %i",&index,name,&red,&green,&blue);
        lut->pushValue((unsigned char)red,(unsigned char)green,(unsigned char)blue,index);
      }
  }

  fclose(fp);
}  
