/*  FSLView - 2D/3D Interactive Image Viewer

    James Saunders, David Flitney and Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2002-2003 University of Oxford  */

/*  CCOPYRIGHT */

#if !defined(TRACKER_H)
#define TRACKER_H

#include <boost/shared_ptr.hpp>
#include <string>
#include <memory>
class Tracker
{
public:
  typedef boost::shared_ptr< Tracker > Handle;

  static Handle create(const std::string& msg);

  void checkpoint();
  void message(const std::string& msg);

  virtual ~Tracker();

private:
  Tracker(const std::string& msg);
  
  const std::string message();
  unsigned int count();

  struct Implementation; 
  const std::auto_ptr<Implementation> m_impl;
};

#if defined(DEBUGGING)

#define TRACKER(s) Tracker::Handle t = Tracker::create(s)
#define CHECKPOINT() t->checkpoint()
#define MESSAGE(s) t->message(s)


#else

#define TRACKER(s)
#define CHECKPOINT()
#define MESSAGE(s)

#endif

#endif
